//The Program for Markov Process Model 
mprintf('_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/\n');
mprintf('_/                                                            _/\n');
mprintf('_/       M A R K O V   P R O C E S S   M O D E L              _/\n');
mprintf('_/       Author:              Shigeru Kido                    _/\n');
mprintf('_/       Update:              June 11, 2014.                  _/\n');
mprintf('_/       Scilab version:      5.5.0                           _/\n');
mprintf('_/       Program Name :       Markov_Model_Ad_case_13         _/\n');
mprintf('_/                                                            _/\n');
mprintf('_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/\n');  
mprintf('\n\n');
//***********************************************************
// Input  data
//***********************************************************
//Title="Ad. test1";
//chain_length=10;   //Number of peiod to estimate
//num_states=3;     // Number of brand in the market
//  initial_state
//current_state2 = [0.30 0.25 0.45];// case 1
  current_state2 = [0.35 0.25 0.40];// case 2
//Transition matrix // 
//B = [0.70 0.03 0.27 ; 0.20 0.64 0.16 ; 0.26 0.10 0.64];//case 1
  B = [0.60 0.12 0.28 ;0.24 0.64 0.12 ; 0.30 0.09 0.61];//case 2
//
 DlgTL =[' MARKOV MODEL :Input Data'];
 txt =[' Case Name ';'Number of State(brand)';'Chain length(Period)'];
 Def1=['Ad. Test 01';'3';'10'];
 ans =x_mdialog(DlgTL,txt,Def1);
Title= ans(1);
num_states=evstr(ans(2)); 
chain_length2=evstr(ans(3));
//
//***********************************************************
// Compute Markov Chain 
//***********************************************************
New_Chain(1,:) = current_state2;
cur_state = current_state2;
for i = 2:chain_length2 
   cur_state = cur_state * B;
   New_Chain(i,:) = cur_state;  
end
//***********************************************************
// Output:  Chain - The first value will be initial_state.          
//***********************************************************
mprintf(' \n\n');
mprintf('============== Markov Process Model Estimation ============= ==== \n');
mprintf('       Case  Title               : %s\n',Title);
mprintf('       Number of Initial_state   : %d\n',num_states);
mprintf('       Chain length to Estimate  : %d\n',chain_length2);
mprintf('----------------------------------------------------------------\n');
mprintf('       Initial State (Current State)\n');
mprintf('----------------------------------------------------------------\n');
for i=1:num_states
    mprintf('        %c    :',ascii(64 + i));
    mprintf('     %8.5f \n',current_state2(i));
end
mprintf('----------------------------------------------------------------\n');
//   
//--------------------------------------------------------------  
mprintf('\n\n'); 
mprintf('  Table of Transition Matrix  (Input): Case[ %s ]\n',Title)
mprintf('----------------------------------------------------------------\n');
mprintf('                          State(j) \n');
mprintf('----------------------------------------------------------------\n');
mprintf(' State(i)');
for i=1:num_states
    mprintf('        %c   ',ascii(64 + i));
end
mprintf('\n');
mprintf('----------------------------------------------------------------\n');
   for  i=1:num_states    
     mprintf( '  %c      ',ascii(64 + i));         
    for j=1:num_states 
      mprintf( '    %8.5f',B(i,j));
    end
    mprintf('\n');
  end
mprintf('----------------------------------------------------------------\n');
mprintf('\n \n'); 
//
mprintf('  Markov Chain Model( Output of New Estimation)\n');
mprintf('----------------------------------------------------------------\n');
mprintf('                          State(i) \n');
mprintf('----------------------------------------------------------------\n');
mprintf('   Time');
for i=1:num_states
    mprintf('         %c   ',ascii(64 + i));
end
mprintf('\n');
mprintf('----------------------------------------------------------------\n');
for i = 1:chain_length2
    mprintf('  [%3d]',i);
   for j= 1:num_states
    mprintf('     %8.5f', New_Chain(i,j));
   end
   mprintf(' \n');
end
mprintf('----------------------------------------------------------------\n');
//
//***********************************************************
//Output graphs
//***********************************************************
clf();
subplot(2,1,1);
pie(current_state2);
xtitle('Markov Chain (initial state) ');
subplot(2,1,2);
bar(New_Chain,'stacked');
//barh(New_Chain,'stacked');
xtitle('Markov Chain Model( Output of New Estimation) ');
//
